<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 23/05/14
 * Time: 09:23
 */

namespace Folha\Logic\ObrigacaoLegal\RAIS;

use \Geral\Repositories\Estruturam;

use \Folha\Repositories\Gpepessoa;

use \Folha\Entities\Fpaformrais;

use \Folha\Entities\GpeVinculom;
use HCM\Util\DateUtil;

class Rais extends TratamentoRais
{

    private $tipo00 = array();
    private $tipo01 = array();
    private $tipo02 = array();
    private $tipo09;
    //private $matriz;

    public function __construct($estruturas, $nrvinculom, $nrorg, $ano,  $nrmatriz, $dadosResp, $sindicato, $grupoIncidencia)
    {
        $this->matriz = $nrmatriz;

        $estruturas = implode(', ', $estruturas);

        $info_01 = Estruturam::getTipo1Rais($ano, $nrorg, $estruturas);
        $info_02 =  new Rais02($nrorg, $ano, $grupoIncidencia, $estruturas, $nrvinculom);
        $info_02 = $info_02->getInfo();

        $this->geraRais($info_01, $info_02, $nrmatriz, $dadosResp, $sindicato);
    }

    public function geraRais($tipo01, $tipo02, $nrmatriz, $dadosResp, $sindicato)
    {
        $this->setTipo01($tipo01, $nrmatriz, $sindicato);
        $this->setTipo02($tipo02);
        $this->setTipo00($dadosResp);
        $this->setTipo09();
    }

    private function setTipo01($regs, $nrmatriz, $sindicato)
    {
        foreach ($regs as $info ) {

            //VERIFICA SE O REGISTRO CORRENTE É A MATRIZ
             if ($nrmatriz === $info['CNPJ']){
                $idmatriz = 1;
                $info['CENTRALIZADORA'] = Null;
                $info['CENTRALIZACAO_PAG_SINDICAL'] = 2;
            }
            else{
                $idmatriz = 2;
                $info['CENTRALIZADORA'] = $nrmatriz;
                $info['CENTRALIZACAO_PAG_SINDICAL'] = 1 ;
            }
            $info['ASSOCIATIVA_PATRONAL'] = $sindicato;
            $info['SINDICATO_PATRONAL'] = $sindicato;

            //INSERE OS VALOR EM UM ATRIBUTO DO OBJETO

            $this->tipo01[] = array(
                'MATRIZ' => $idmatriz,
                'NRORG' => $info['NRORG'],
                'NRESTRUTURAM' => $info['NRESTRUTURAM'],
                'REGISTRO' => $info
            );

            sort($this->tipo01);
        }
        
    }
    public function getTipo01()
    {
        $linhas = array();
        foreach ($this->tipo01 as $reg) {

            //PEGA OS DADOS DO ARRAY E OS TRATA

            $linha = $this->zeroInicial($reg['REGISTRO']['CNPJ'], 14);
            $linha .= $this->espacoFinal($reg['REGISTRO']['PREFIXO'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['TIPO_REGISTRO'], 1);
            $linha .= $this->espacoFinal($reg['REGISTRO']['RAZAO_SOCIAL'], 52);
            $linha .= $this->espacoFinal($reg['REGISTRO']['LOGRADOURO'], 40);
            $linha .= $this->zeroInicial($reg['REGISTRO']['NUMERO'], 6);
            $linha .= $this->espacoFinal($reg['REGISTRO']['COMPLEMENTO'], 21);
            $linha .= $this->espacoFinal($reg['REGISTRO']['BAIRRO'], 19);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CEP'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CODIGO_MUNICIPIO'], 7);
            $linha .= $this->espacoFinal($reg['REGISTRO']['MUNICIPIO'], 30);
            $linha .= $this->espacoFinal($reg['REGISTRO']['SIGLA_ESTADO'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['DDD'], 2);
            $linha .= $this->trataTelefone($reg['REGISTRO']['TELEFONE']);
            $linha .= strtoupper(str_pad($reg['REGISTRO']['EMAIL'], 45, ' ', STR_PAD_RIGHT));
            $linha .= $this->zeroInicial($reg['REGISTRO']['CNAE'], 7);
            $linha .= $this->zeroInicial($reg['REGISTRO']['NATUREZA_JURIDICA'], 4);
            $linha .= $this->zeroInicial($reg['REGISTRO']['NUMERO_PROPRIETARIOS'], 4);
            $linha .= $this->tratarData($reg['REGISTRO']['DATA_BASE'],'m', 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['TIPO_INSCRICAO'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['TIPO_RAIS'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['ZEROS'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CEI'], 12);
            $linha .= $this->zeroInicial($reg['REGISTRO']['ANO'], 4);
            $linha .= $this->zeroInicial($reg['REGISTRO']['PORTE_EMPRESA'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['OPT_SIMPLES'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['PAT'], 1);
            $linha .= $this->validaValorPAT($reg['REGISTRO']['MAIS_5_SALARIOS'], $reg['REGISTRO']['PAT']);
            $linha .= $this->validaValorPAT($reg['REGISTRO']['MENOS_5_SALARIOS'], $reg['REGISTRO']['PAT']);
            $linha .= $this->zeroInicial($reg['REGISTRO']['SERVICO_PROPRIO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['ADMINISTRACAO_COZINHA'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REFEICAO_CONVENIO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REFEICAO_TRANSPORTADA'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CESTA_ALIMENTO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['ALIMENTACAO_CONVENIO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['ENCERROU_ATIVIDADE'], 1);
            $linha .= $this->tratarData($reg['REGISTRO']['DATA_ENCERRAMENTO'], 'dmY');
            $linha .= $this->zeroInicial($reg['REGISTRO']['ASSOCIATIVA_PATRONAL'], 14);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_ASSOCIATIVA_PATRONAL'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['SINDICATO_PATRONAL'], 14);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_SINDICATO_PATRONAL'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['ASSISTENCIAL_PATRONAL'], 14);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_ASSISTENCIAL_PATRONAL'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CONFEDERATIVA_PATRONAL'], 14);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_CONFEDERATIVA_PATRONAL'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['ATIVIDADE_ANO_BASE'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CENTRALIZACAO_PAG_SINDICAL'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CENTRALIZADORA'], 14);
            $linha .= $this->zeroInicial($reg['REGISTRO']['EMPRESA_FILIADA'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['TIPO_CONTROLE_PONTO'], 2);
            $linha .= $this->espacoFinal($reg['REGISTRO']['ESPACOS'], 85);
            $linha .= $this->espacoFinal($reg['REGISTRO']['EXCLUSIVO_EMPRESA'], 12);

            $linhas[] = array(
                'NRESTRUTURAM' => $reg['REGISTRO']['NRESTRUTURAM'],
                'CNPJ' => $reg['REGISTRO']['NRESTRUTURAM'],
                'RAZAO_SOCIAL' => $reg['REGISTRO']['RAZAO_SOCIAL'],
                'REGISTRO' => $linha);
            
        }

        return $linhas;
    }

    private function setTipo02($regs)
    {
           
        //INSERE OS ATRIBUTOS EM UM ATRIBUTO DO OBJETO
        foreach ($regs as $info){
            $this->tipo02[] = array(
                'NRORG' => $info['NRORG'],
                'NRESTRUTURAM' => $info['NRESTRUTURAM'],
                'NRVINCULOM' => $info['NRVINCULOM'],
                'NRPESSOA' => $info['NRPESSOA'],
                'REGISTRO' => $info
            );
        }
        
    }
    public function getTipo02()
    {
        $linhas = array();

        foreach ($this->tipo02 as $reg) {
            //PEGA OS DADOS DO ARRAY E OS TRATA

            $linha = $this->zeroInicial($reg['REGISTRO']['CNPJ'], 14);
            $linha .= $this->zeroInicial($reg['REGISTRO']['PREFIXO'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['TIPO_REGISTRO'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['PIS_PASEP'], 11);
//            $linha .= $this->espacoFinal($reg['REGISTRO']['NOME'], 52);
            $linha .= $this->espacoFinal(mb_ereg_replace('[-_\d]+',' SOBRENOME',$reg['REGISTRO']['NOME']), 52);
            $linha .= $this->tratarData($reg['REGISTRO']['DATA_NASCIMENTO'], 'dmY');
            $linha .= $this->zeroInicial($reg['REGISTRO']['NACIONALIDADE'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['ANO_CHEGADA'], 4);
            $linha .= $this->zeroInicial($reg['REGISTRO']['GRAU_INSTRUCAO'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CPF'], 11);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CTPS'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['SERIE_CTPS'], 5);
            $linha .= $this->tratarData($reg['REGISTRO']['DATA_ADMISSAO'], 'dmY');
            $linha .= $this->zeroInicial($reg['REGISTRO']['TIPO_ADMISSAO'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['SALARIO_CONTRATUAL'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['TIPO_PAGAMENTO'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_SEMANAIS'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CBO'], 6);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VINCULO'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['TIPO_RECISÃO'], 2);
            $linha .= $this->tratarData($reg['REGISTRO']['DATA_RECISAO'], 'dm', 4);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_JANEIRO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_FEVEREIRO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_MARCO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_ABRIL'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_MAIO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_JUNHO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_JULHO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_AGOSTO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_SETEMBRO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_OUTUBRO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_NOVEMBRO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['REMUNERACAO_DEZEMBRO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['ADIANTAMENTO_DTERCEIRO'], 9);
            $linha .= $this->tratarData($reg['REGISTRO']['MES_ADIANT_DTERCEIRO'], 'm', 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['RESTANTE_DTERCEIRO'], 9);
            $linha .= $this->tratarData($reg['REGISTRO']['MES_RESTANT_DTERCEIRO'],'m', 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['RACA'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['DEFICIENCIA'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['TIPO_DEFICIENCIA'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['INDICADOR_ALVARA'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['AVISO_INDENIZADO'], 9);
            $linha .= $this->zeroInicial($reg['REGISTRO']['SEXO'], 1);
            $linha .= $this->zeroInicial($reg['REGISTRO']['PRIMEIRO_AFASTAMENTO'], 2);
            $linha .= $this->tratarData($reg['REGISTRO']['DT_INI_PRI_AFASTAMEN'],'dm', 4);
            $linha .= $this->tratarData($reg['REGISTRO']['DT_FIM_PRI_AFASTAMEN'],'dm', 4);
            $linha .= $this->zeroInicial($reg['REGISTRO']['SEGUNDO_AFASTAMENTO'], 2);
            $linha .= $this->tratarData($reg['REGISTRO']['DT_INI_SEG_AFASTAMEN'],'dm', 4);
            $linha .= $this->tratarData($reg['REGISTRO']['DT_FIM_SEG_AFASTAMEN'],'dm', 4);
            $linha .= $this->zeroInicial($reg['REGISTRO']['TERCEIRO_AFASTAMENTO'], 2);
            $linha .= $this->tratarData($reg['REGISTRO']['DT_INI_TER_AFASTAMEN'],'dm', 4);
            $linha .= $this->tratarData($reg['REGISTRO']['DT_FIM_TER_AFASTAMEN'],'dm', 4);
            $linha .= $this->zeroInicial($reg['REGISTRO']['DIAS_AFASTAMENTO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['FERIAS_INDENIZADAS'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_BANCO_HORAS'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['QUAT_MESES_BANCO_HORAS'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_DISSIDIO'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['MESES_DISSIDIO'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_GRATIFICACAO'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['MESES_GRATIFICACAO'], 2);
            $linha .= $this->zeroInicial($reg['REGISTRO']['MULTA_REC_SEM_JUSTCAUSA'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CNPJ_CONT_ASSOC_1'], 14);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_CONT_ASSOC_1'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CNPJ_CONT_ASSOC_2'], 14);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_CONT_ASSOC_2'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CNPJ_CONT_SINDI'], 14);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_CONT_SINDI'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CNPJ_CONT_ASSIST'], 14);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_CONT_ASSIST'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['CNPJ_CONT_CONFED'], 14);
            $linha .= $this->zeroInicial($reg['REGISTRO']['VALOR_CONT_CONFED'], 8);
            $linha .= $this->zeroInicial($reg['REGISTRO']['MUNICIPIO_TRABALHO'], 7);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_JANEIRO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_FEVEREIRO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_MARCO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_ABRIL'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_MAIO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_JUNHO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_JULHO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_AGOSTO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_SETEMBRO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_OUTUBRO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_NOVEMBRO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['HORAS_EXTRA_DEZEMBRO'], 3);
            $linha .= $this->zeroInicial($reg['REGISTRO']['FILIADO_SINDICATO'], 1);
            $linha .= $this->espacoFinal($reg['REGISTRO']['INF_EXCLUSIVO_EMPRESA'], 12);

            $linhas[] = array(
                'NRESTRUTURAM' => $reg['REGISTRO']['NRESTRUTURAM'],
                'NRVINCULOM' => $reg['REGISTRO']['NRVINCULOM'],
                'CNPJ' => $reg['REGISTRO']['CNPJ'],
                'DTADMISSAO' => $this->tratarData($reg['REGISTRO']['DATA_ADMISSAO'], 'd/m/Y'),
                'NRPISPASEP' => $reg['REGISTRO']['PIS_PASEP'],
                'REGISTRO' => $linha);
        }
        sort($linhas);

        return $linhas;
        
    }
    
    private function setTipo00($dadosResp)
    {
        foreach($this->tipo01 as $estrutura){
            if($estrutura['MATRIZ'] === 1){
                $this->tipo00['CNPJ'] = $this->tipo01[0]['REGISTRO']['CNPJ'];
                $this->tipo00['PREFIXO'] = $this->tipo01['REGISTRO']['PREFIXO'];
                $this->tipo00['TIPO_REGISTRO'] = 0;
                $this->tipo00['CONSTANTE'] = 1;
                $this->tipo00['RESPONS_CNPJ'] = $dadosResp['CNPJ'];
                $this->tipo00['RESPONS_TIPO_INSC'] = $dadosResp['TIPO_INSCRICAO'];
                $this->tipo00['RESPONS_RAZAO'] = $dadosResp['RAZAO'];
                $this->tipo00['RESPONS_LOGRA'] = $dadosResp['LOGRADOURO'];
                $this->tipo00['RESPONS_NUMER'] = $dadosResp['NUMERO'];
                $this->tipo00['RESPONS_COMPL'] = $dadosResp['COMPLEMENTO'];
                $this->tipo00['RESPONS_BAIRR'] = $dadosResp['BAIRRO'];
                $this->tipo00['RESPONS_CEP'] = $dadosResp['CEP'];
                $this->tipo00['RESPONS_CDMUN'] = $dadosResp['CDMUNICIPIO'];
                $this->tipo00['RESPONS_NMMUN'] = $dadosResp['NMMUNICIPIO'];
                $this->tipo00['RESPONS_UF'] = $dadosResp['UF'];
                $this->tipo00['RESPONS_DDD'] = $dadosResp['DDD'];
                $this->tipo00['RESPONS_TELEF'] = $dadosResp['TELEFONE'];
                $this->tipo00['DATA_ARQUIVO'] = DateUtil::getDataAtual()->format('dmY');
                $this->tipo00['EMAIL'] = $dadosResp['EMAIL'];
                $this->tipo00['NOME'] = $dadosResp['NOME'];
                $this->tipo00['NOME'] = mb_ereg_replace('[-_\d]+',' SOBRENOME',$this->tipo00['NOME']);
                $this->tipo00['ESPACOS_1'] = '';
                $this->tipo00['CPF'] = $dadosResp['CPF'];
                $this->tipo00['CREA'] = $dadosResp['CREA'];
                $this->tipo00['DATA_NASCIMENTO'] = $dadosResp['DATA_NASCIMENTO'];
                $this->tipo00['ESPACOS_2'] = '';
                $this->tipo00['RETIFICA_ID'] = $dadosResp['RETIFICA_ID'];
                $this->tipo00['RETIFICA_DATA'] = $dadosResp['RETIFICA_DATA'];
            }
        }
        
    }
    public function getTipo00()
    {
        $linha = '';
        $linha .= $this->zeroInicial($this->tipo00['CNPJ'], 14);
        $linha .= $this->zeroInicial($this->tipo00['PREFIXO'], 2);
        $linha .= $this->tipo00['TIPO_REGISTRO'];
        $linha .= $this->tipo00['CONSTANTE'];
        $linha .= $this->zeroInicial($this->tipo00['RESPONS_CNPJ'], 14);

        $linha .= $this->tipo00['RESPONS_TIPO_INSC'];
        $linha .= $this->espacoFinal($this->tipo00['RESPONS_RAZAO'], 40);
        $linha .= $this->espacoFinal($this->tipo00['RESPONS_LOGRA'], 40);
        $linha .= $this->zeroInicial($this->tipo00['RESPONS_NUMER'], 06);
        $linha .= $this->espacoFinal($this->tipo00['RESPONS_COMPL'], 21);
        $linha .= $this->espacoFinal($this->tipo00['RESPONS_BAIRR'], 19);
        $linha .= $this->zeroInicial($this->tipo00['RESPONS_CEP'], 8);
        $linha .= $this->zeroInicial($this->tipo00['RESPONS_CDMUN'], 7);
        $linha .= $this->espacoFinal($this->tipo00['RESPONS_NMMUN'], 30);
        $linha .= $this->espacoFinal($this->tipo00['RESPONS_UF'], 2);
        $linha .= $this->zeroInicial($this->tipo00['RESPONS_DDD'], 2);
        $linha .= $this->trataTelefone($this->tipo00['RESPONS_TELEF']);
        $linha .= $this->tipo00['RETIFICA_ID'];
        $linha .= $this->tratarData($this->tipo00['RETIFICA_DATA'], 'dmY', 8);
        $linha .= $this->tratarData($this->tipo00['DATA_ARQUIVO'],'dmY', 8);
        $linha .= strtoupper(str_pad($this->tipo00['EMAIL'], 45, ' ', STR_PAD_RIGHT));
        $linha .= $this->espacoFinal($this->tipo00['NOME'], 52);
        $linha .= $this->espacoFinal($this->tipo00['ESPACOS_1'], 24);
        $linha .= $this->zeroInicial($this->tipo00['CPF'], 11);
        $linha .= $this->zeroInicial($this->tipo00['CREA'], 12);
        $linha .= $this->tratarData($this->tipo00['DATA_NASCIMENTO'], 'dmY', 8);
        $linha .= $this->espacoFinal($this->tipo00['ESPACOS_2'], 159);

        $linhas = array(
            'CNPJ' => $this->tipo00['CNPJ'],
            'RAZAO_SOCIAL' => $this->tipo00['RESPONS_RAZAO'],
            'REGISTRO' => $linha
        );
        return $linhas;

    }

    private function setTipo09()
    {
        $qRegTipo01 = count($this->tipo01);
        $qRegTipo02 = count($this->tipo02);

        $this->tipo09['CNPJ'] = $this->tipo01[$qRegTipo01-1]['REGISTRO']['CNPJ'];
        $this->tipo09['PREFIXO'] = $this->tipo01[$qRegTipo01-1]['REGISTRO']['PREFIXO'];
        $this->tipo09['TIPO_REGISTRO'] = 9;
        $this->tipo09['TOTAL_TIPO_01'] = $qRegTipo01;
        $this->tipo09['TOTAL_TIPO_02'] = $qRegTipo02;
        $this->tipo09['ESPACOS'] = '';
    }

    public function getTipo09()
    {
        $linha = $this->zeroInicial($this->tipo09['CNPJ'],14);
        $linha .= $this->zeroInicial($this->tipo09['PREFIXO'], 2);
        $linha .= $this->tipo09['TIPO_REGISTRO'];
        $linha .= $this->zeroInicial($this->tipo09['TOTAL_TIPO_01'], 6);
        $linha .= $this->zeroInicial($this->tipo09['TOTAL_TIPO_02'], 6);
        $linha .= $this->espacoInicial($this->tipo09['ESPACOS'], 516);
        return $linha;
    }



}