<?php

namespace Geral\Logic\Prospect;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

/**
 * Created by JetBrains PhpStorm.
 * User: paulopimenta
 * Date: 10/04/13
 * Time: 11:08
 * To change this template use File | Settings | File Templates.
 */
class Prospect
{
    public static function alterarInscricaoRazaoSocialNomeFantasia(\Geral\Entities\Prospect $prospect, $inscricao, $razaoSocial, $nomeFantasia){
        $manager = \Setforms2\Shared\Registry::getEntityManager();

        $prospect->setNrinsjurpros($inscricao);
        $prospect->setNmrazsocpros($razaoSocial);
        $prospect->setNmfantpros($nomeFantasia);

        $prospect->persist();

        $manager->flush();
    }

    public static function incluirInterlocutorProspect($campos){
        $manager = \Setforms2\Shared\Registry::getEntityManager();

        $interlocutor = new \Geral\Entities\Inteprosp();

        $interlocutor->setNrorg(Ambiente::getNrorg());
        $interlocutor->setCdprospect($campos['CDPROSPECT']['']);
        $interlocutor->setCdintepros($campos['CDINTEPROS']['']);
        $interlocutor->setNmintepros($campos['NMINTEPROS']['']);
        $interlocutor->setIdtpintepros($campos['IDTPINTEPROS']['']);
        $interlocutor->setDscarginpros($campos['DSCARGINPROS']['']);

        if(isset($campos['DTNASCINPROS']['']) && $campos['DTNASCINPROS'][''] != '') {
            $dataNascimento = DateUtil::getDataDeString($campos['DTNASCINPROS'][''], DateUtil::FORMATO_BRASILEIRO, true);
            $interlocutor->setDtnascinpros($dataNascimento);
        }

        $interlocutor->setDtinclusao(DateUtil::getDataAtual());
        $interlocutor->setIdinprosrecpres('N');
        $interlocutor->setDsemailipros($campos['DSEMAILIPROS']['']);
        $interlocutor->setNrfaxinpros($campos['NRFAXINPROS']['']);
        $interlocutor->setNrtel1inpros($campos['NRTEL1INPROS']['']);
        $interlocutor->setNrram1inpros($campos['NRRAM1INPROS']['']);
        $interlocutor->setNrtel2inpros($campos['NRTEL2INPROS']['']);
        $interlocutor->setNrram2inpros($campos['NRRAM2INPROS']['']);
        $interlocutor->setNrcelulinpro($campos['NRCELULINPRO']['']);
        $interlocutor->setNrtelreinpro($campos['NRTELREINPRO']['']);
        $interlocutor->setIdendeinpros($campos['IDENDEINPROS']['']);
        $interlocutor->setDsendeinpros($campos['DSENDEINPROS']['']);
        $interlocutor->setNmbairinpros($campos['NMBAIRINPROS']['']);
        $interlocutor->setNrcepinpros($campos['NRCEPINPROS']['']);
        $interlocutor->setCdpais($campos['CDPAIS']['']);
        $interlocutor->setSgestado($campos['SGESTADO']['']);
        $interlocutor->setCdmunicipio($campos['CDMUNICIPIO']['']);

        $interlocutor->persist();

        $manager->flush();
    }
}
